## afl 1.83b

=== Makefile ===
#
# american fuzzy lop - makefile
# -----------------------------
#
# Written and maintained by Michal Zalewski <lcamtuf@google.com>
# 
# Copyright 2013, 2014, 2015 Google Inc. All rights reserved.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
# 
#   http://www.apache.org/licenses/LICENSE-2.0
#

PROGNAME    = afl
VERSION     = 1.83b

PREFIX     ?= /usr/local
BIN_PATH    = $(PREFIX)/bin
HELPER_PATH = $(PREFIX)/lib/afl
DOC_PATH    = $(PREFIX)/share/doc/afl
MISC_PATH   = $(PREFIX)/share/afl

PROGS       = afl-gcc afl-as afl-fuzz afl-showmap afl-tmin afl-gotcpu

CFLAGS     ?= -O3 -funroll-loops
CFLAGS     += -Wall -D_FORTIFY_SOURCE=2 -g -Wno-pointer-sign \
	      -DAFL_PATH=\"$(HELPER_PATH)\" -DDOC_PATH=\"$(DOC_PATH)\" \
	      -DBIN_PATH=\"$(BIN_PATH)\" -DVERSION=\"$(VERSION)\"

ifneq "$(filter Linux GNU%,$(shell uname))" ""
  LDFLAGS  += -ldl
endif

ifeq "$(findstring clang, $(shell $(CC) --version 2>/dev/null))" ""
  TEST_CC   = afl-gcc
else
  TEST_CC   = afl-clang
endif

COMM_HDR    = alloc-inl.h config.h debug.h types.h

all: test_x86 $(PROGS) test_build all_done

ifndef AFL_NOX86

test_x86:
	@echo "[*] Checking for the ability to compile x86 code..."
	@echo 'main() { __asm__("xorb %al, %al"); }' | $(CC) -w -x c - -o .test || ( echo; echo "Oops, looks like your compiler can't generate x86 code."; echo; echo "You can still try using the LLVM or QEMU mode, but see docs/INSTALL first."; echo "To ignore this error, set AFL_NOX86=1."; echo; exit 1 )
	@rm -f .test
	@echo "[+] Everything seems to be working, ready to compile."

else

test_x86:
	@echo "[!] Note: skipping x86 compilation checks (AFL_NOX86 set)."

endif

afl-gcc: afl-gcc.c $(COMM_HDR) | test_x86
	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS)
	set -e; for i in afl-g++ afl-clang afl-clang++; do ln -sf afl-gcc $$i; done

afl-as: afl-as.c afl-as.h $(COMM_HDR) | test_x86
	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS) 
	ln -sf afl-as as

afl-fuzz: afl-fuzz.c $(COMM_HDR) | test_x86
	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS)

afl-showmap: afl-showmap.c $(COMM_HDR) | test_x86
	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS)

afl-tmin: afl-tmin.c $(COMM_HDR) | test_x86
	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS)

afl-gotcpu: afl-gotcpu.c $(COMM_HDR) | test_x86
	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS)

ifndef AFL_NOX86

test_build: afl-gcc afl-as afl-showmap
	@echo "[*] Testing the CC wrapper and instrumentation output..."
	unset AFL_USE_ASAN AFL_USE_MSAN; AFL_QUIET=1 AFL_INST_RATIO=100 AFL_PATH=. ./$(TEST_CC) $(CFLAGS) test-instr.c -o test-instr $(LDFLAGS)
	echo 0 | ./afl-showmap -m none -q -o .test-instr0 ./test-instr
	echo 1 | ./afl-showmap -m none -q -o .test-instr1 ./test-instr
	@rm -f test-instr
	@cmp -s .test-instr0 .test-instr1; DR="$$?"; rm -f .test-instr0 .test-instr1; if [ "$$DR" = "0" ]; then echo; echo "Oops, the instrumentation does not seem to be behaving correctly!"; echo; echo "Please ping <lcamtuf@google.com> to troubleshoot the issue."; echo; exit 1; fi
	@echo "[+] All right, the instrumentation seems to be working!"

else

test_build: afl-gcc afl-as afl-showmap
	@echo "[!] Note: skipping build tests (you may need to use LLVM or QEMU mode)."

endif

all_done: test_build
	@echo "[+] All done! Be sure to review README - it's pretty short and useful."
	@if [ "`uname`" = "Darwin" ]; then printf "\nWARNING: Fuzzing on MacOS X is slow because of the unusually high overhead of\nfork() on this OS. Consider using Linux or *BSD. You can also use VirtualBox\n(virtualbox.org) to put AFL inside a Linux or *BSD VM.\n\n"; fi
	@! tty <&1 >/dev/null || printf "\033[0;30mNOTE: If you can read this, your terminal probably uses white background.\nThis will make the UI hard to read. See docs/status_screen.txt for advice.\033[0m\n" 2>/dev/null

.NOTPARALLEL: clean

clean:
	rm -f $(PROGS) as afl-g++ afl-clang afl-clang++ *.o *~ a.out core core.[1-9][0-9]* *.stackdump test .test test-instr .test-instr0 .test-instr1 qemu_mode/qemu-2.3.0.tar.bz2 afl-qemu-trace
	rm -rf out_dir qemu_mode/qemu-2.3.0
	$(MAKE) -C llvm_mode clean

install: all
	mkdir -p -m 755 $${DESTDIR}$(BIN_PATH) $${DESTDIR}$(HELPER_PATH) $${DESTDIR}$(DOC_PATH) $${DESTDIR}$(MISC_PATH)
	rm -f $${DESTDIR}$(BIN_PATH)/afl-plot.sh
	install -m 755 afl-gcc afl-fuzz afl-showmap afl-plot afl-tmin afl-cmin afl-gotcpu afl-whatsup $${DESTDIR}$(BIN_PATH)
	if [ -f afl-qemu-trace ]; then install -m 755 afl-qemu-trace $${DESTDIR}$(BIN_PATH); fi
	if [ -f afl-clang-fast -a -f afl-llvm-pass.so -a -f afl-llvm-rt.o ]; then set -e; install -m 755 afl-clang-fast $${DESTDIR}$(BIN_PATH); ln -sf afl-clang-fast $${DESTDIR}$(BIN_PATH)/afl-clang-fast++; install -m 755 afl-llvm-pass.so afl-llvm-rt.o $${DESTDIR}$(HELPER_PATH); fi
	set -e; for i in afl-g++ afl-clang afl-clang++; do ln -sf afl-gcc $${DESTDIR}$(BIN_PATH)/$$i; done
	install -m 755 afl-as $${DESTDIR}$(HELPER_PATH)
	ln -sf afl-as $${DESTDIR}$(HELPER_PATH)/as
	install -m 644 docs/README docs/ChangeLog docs/*.txt $${DESTDIR}$(DOC_PATH)
	cp -r testcases/ $${DESTDIR}$(MISC_PATH)

publish: clean
	test "`basename $$PWD`" = "afl" || exit 1
	test -f ~/www/afl/releases/$(PROGNAME)-$(VERSION).tgz; if [ "$$?" = "0" ]; then echo; echo "Change program version in Makefile, mmkay?"; echo; exit 1; fi
	cd ..; rm -rf $(PROGNAME)-$(VERSION); cp -pr $(PROGNAME) $(PROGNAME)-$(VERSION); \
	  tar -cvz -f ~/www/afl/releases/$(PROGNAME)-$(VERSION).tgz $(PROGNAME)-$(VERSION)
	chmod 644 ~/www/afl/releases/$(PROGNAME)-$(VERSION).tgz
	( cd ~/www/afl/releases/; ln -s -f $(PROGNAME)-$(VERSION).tgz $(PROGNAME)-latest.tgz )
	cat docs/README >~/www/afl/README.txt
	cat docs/status_screen.txt >~/www/afl/status_screen.txt
	cat docs/historical_notes.txt >~/www/afl/historical_notes.txt
	cat docs/technical_details.txt >~/www/afl/technical_details.txt
	cat docs/ChangeLog >~/www/afl/ChangeLog.txt
	echo -n "$(VERSION)" >~/www/afl/version.txt

=== llvm_mode/Makefile ===
#
# american fuzzy lop - LLVM instrumentation
# -----------------------------------------
#
# Written by Laszlo Szekeres <lszekeres@google.com> and
#            Michal Zalewski <lcamtuf@google.com>
#
# LLVM integration design comes from Laszlo Szekeres.
#
# Copyright 2015 Google Inc. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#

PREFIX      ?= /usr/local
HELPER_PATH  = $(PREFIX)/lib/afl
BIN_PATH     = $(PREFIX)/bin

VERSION      = $(shell grep ^VERSION ../Makefile | cut -d= -f2 | sed 's/ //')

LLVM_CONFIG ?= llvm-config

CFLAGS      ?= -O3 -funroll-loops
CFLAGS      += -Wall -D_FORTIFY_SOURCE=2 -g -Wno-pointer-sign \
               -DAFL_PATH=\"$(HELPER_PATH)\" -DBIN_PATH=\"$(BIN_PATH)\" \
               -DVERSION=\"$(VERSION)\"

CXXFLAGS    ?= -O3 -funroll-loops
CXXFLAGS    += -Wall -D_FORTIFY_SOURCE=2 -g -Wno-pointer-sign \
               -DVERSION=\"$(VERSION)\"

CLANG_CFL    = `$(LLVM_CONFIG) --cxxflags` -fno-rtti $(CXXFLAGS)
CLANG_LFL    = `$(LLVM_CONFIG) --ldflags` $(LDFLAGS)

# User teor2345 reports that this is required to make things work on MacOS X.

ifeq "$(shell uname)" "Darwin"

CLANG_LFL   += -Wl,-flat_namespace -Wl,-undefined,suppress

endif

# We were using llvm-config --bindir to get the location of clang, but
# this seems to be busted on some distros, so using the one in $PATH is
# probably better.

ifeq "$(origin CC)" "default"

CC           = clang
CXX          = clang++

endif

PROGS        = ../afl-clang-fast ../afl-llvm-pass.so ../afl-llvm-rt.o

all: test_deps $(PROGS) test_build all_done

test_deps:
	@echo "[*] Checking for working 'llvm-config'..."
	@which $(LLVM_CONFIG) >/dev/null 2>&1 || ( echo "[-] Oops, can't find 'llvm-config'. Install clang or set \$$LLVM_CONFIG or \$$PATH beforehand."; echo "    (Sometimes, the binary will be named llvm-config-3.5 or something like that.)"; exit 1 )
	@echo "[*] Checking for working '$(CC)'..."
	@which $(CC) >/dev/null 2>&1 || ( echo "[-] Oops, can't find '$(CC)'. Make sure that it's in your \$$PATH (or set \$$CC and \$$CXX)."; exit 1 )
	@echo "[*] Checking for '../afl-showmap'..."
	@test -f ../afl-showmap || ( echo "[-] Oops, can't find '../afl-showmap'. Be sure to compile AFL first."; exit 1 )
	@echo "[+] All set and ready to build."

../afl-clang-fast: afl-clang-fast.c | test_deps
	$(CC) $(CFLAGS) $< -o $@ $(LDFLAGS)
	ln -sf afl-clang-fast ../afl-clang-fast++

../afl-llvm-pass.so: afl-llvm-pass.so.cc | test_deps
	$(CXX) $(CLANG_CFL) -shared $< -o $@ $(CLANG_LFL)

../afl-llvm-rt.o: afl-llvm-rt.o.c | test_deps
	$(CC) $(CFLAGS) -fPIC -c $< -o $@

test_build: $(PROGS)
	@echo "[*] Testing the CC wrapper and instrumentation output..."
	unset AFL_USE_ASAN AFL_USE_MSAN AFL_DEFER_FORKSRV; AFL_QUIET=1 AFL_INST_RATIO=100 AFL_PATH=. AFL_CC=$(CC) ../afl-clang-fast $(CFLAGS) ../test-instr.c -o test-instr $(LDFLAGS)
	echo 0 | ../afl-showmap -m none -q -o .test-instr0 ./test-instr
	echo 1 | ../afl-showmap -m none -q -o .test-instr1 ./test-instr
	@rm -f test-instr
	@cmp -s .test-instr0 .test-instr1; DR="$$?"; rm -f .test-instr0 .test-instr1; if [ "$$DR" = "0" ]; then echo; echo "Oops, the instrumentation does not seem to be behaving correctly!"; echo; echo "Please ping <lcamtuf@google.com> to troubleshoot the issue."; echo; exit 1; fi
	@echo "[+] All right, the instrumentation seems to be working!"

all_done: test_build
	@echo "[+] All done! You can now use '../afl-clang-fast' to compile programs."

.NOTPARALLEL: clean

clean:
	rm -f *.o *.so *~ a.out core core.[1-9][0-9]* test-instr .test-instr0 .test-instr1 
	rm -f $(PROGS) ../afl-clang-fast++

=== debian/changelog ===
afl (1.83b-1) unstable; urgency=low

  * New upstream release:
    + Fix a harmless but annoying race condition in persistent mode.
    + Tweak AFL_PERSISTENT to force AFL_NO_VAR_CHECK.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 24 Jun 2015 16:36:42 +0200

afl (1.81b-1) unstable; urgency=low

  * New upstream release:
    + Add persistent mode for in-process fuzzing.
    + Change the in-place resume code to preserve crashes/README.txt.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 11 Jun 2015 11:24:47 +0200

afl (1.80b-1) unstable; urgency=low

  * New upstream release:
    + Make afl-cmin tolerant of whitespaces in filenames.
    + Add support for AFL_EXIT_WHEN_DONE (causes afl-fuzz to terminate when
      all existing paths have been fuzzed and there were no new finds for
      a while).

 -- Jakub Wilk <jwilk@debian.org>  Wed, 03 Jun 2015 17:09:11 +0200

afl (1.79b-1) unstable; urgency=low

  * New upstream release:
    + Replace dictionaries with file-based variants.
    + Fix reporting token sizes for file-based dictionaries.
    + Added support for dictionary levels.
  * Disable stack protector on kfreebsd-*, powerpc and ppc64el for the clang
    compiler (see bug #785365).

 -- Jakub Wilk <jwilk@debian.org>  Sat, 23 May 2015 12:04:02 +0200

afl (1.77b-1) unstable; urgency=low

  * New upstream release:
    + Extend the -x option to support single-file dictionaries.

 -- Jakub Wilk <jwilk@debian.org>  Sun, 10 May 2015 23:16:22 +0200

afl (1.76b-1) unstable; urgency=low

  * New upstream release:
    + afl-clang-fast now defines __AFL_HAVE_MANUAL_INIT.
    + Fix a libtool-related bug with afl-clang-fast that would make some
      ./configure invocations generate incorrect output.
    + Reduce the number of duplicate execs during deterministic checks.
    + Reduce the likelihood of duplicate non-deterministic execs.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 05 May 2015 13:37:31 +0200

afl (1.74b-1) unstable; urgency=low

  * New upstream release:
    + Fix a bug in effector maps that could sometimes cause AFL to fuzz
      slightly more than necessary; and in rare circumstances, could lead to
      segmentation fault.
    + Improve afl-tmin to use /tmp if cwd is not writeable.
    + In LLVM mode, insert the instrumentation even when AFL_DONT_OPTIMIZE=1
      is set.
  * Fix version constraints in afl-clang's Breaks and Replaces.

 -- Jakub Wilk <jwilk@debian.org>  Sat, 02 May 2015 15:50:54 +0200

afl (1.72b-1) unstable; urgency=low

  * New upstream release:
    + Add last path, crash and hang times to fuzzer_stats.
  * Enable LLVM-based instrumentation.
    + Add llvm-dev and clang to Build-Depends.
    + Add new binary package “afl-clang”, containing both the old
      afl-clang(++) and LLVM-based afl-clang-fast(++).
    + Make “afl” recommend “afl-clang”.
    + Make both binary packages “Architecture: any”.
    + Update debian/rules and add *.install files to support “afl-clang”.
    + Update DEP-8 tests to support “afl-clang”.

 -- Jakub Wilk <jwilk@debian.org>  Sat, 25 Apr 2015 20:06:33 +0200

afl (1.70b-1) unstable; urgency=low

  * New upstream release:
    + Refactor afl-tmin to reduce the number of execs in common use cases.
    + Add MEM_BARRIER() to afl-showmap and afl-tmin, just to be safe.
    + Remove build date and time from banners to give people deterministic
      builds.
    + Fix a minor PRNG glitch that would make the first seconds of a fuzzing
      job deterministic.
    + Modify resumption code to reuse the original timeout value when resuming
      a session if -t is not given. This prevents timeout creep in continuous
      fuzzing.
  * Extend the DEP-8 tests.

 -- Jakub Wilk <jwilk@debian.org>  Sat, 18 Apr 2015 18:41:07 +0200

afl (1.58b-1) unstable; urgency=low

  * Upload to unstable (closes: #781802).
    Thanks to Ondřej Surý for the bug report.
  * New upstream release:
    + Tweak afl-gcc to use BIN_PATH instead of a fixed string in help
      messages (closes: #779921). Thanks to Ph. Marek for the bug report.

 -- Jakub Wilk <jwilk@debian.org>  Fri, 03 Apr 2015 23:16:47 +0200

afl (1.56b-1) experimental; urgency=low

  * New upstream release:
    + Make it possible to properly override LD_BIND_NOW.
    + Fix a bug in AFL_DUMB_FORKSRV.
    + Fix a bug with afl-showmap opening /dev/null with O_RDONLY when
      running in quiet mode.
    + Add support for file format postprocessors.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 05 Mar 2015 12:51:32 +0100

afl (1.50b-1) experimental; urgency=low

  * New upstream release:
    + Save original command line in fuzzer_stats and crashes/README.txt. Also
      save fuzzer version in fuzzer_stats.
    + Improve file descriptor handling.
    + Fix a flock() bug that would prevent dir reuse errors from kicking
      in every now and then.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 26 Feb 2015 20:08:57 +0100

afl (1.47b-1) experimental; urgency=low

  * New upstream release:
    + Replace zero-sized files with symlinks in the variable behavior state
      dir to simplify examining the relevant test cases.
    + Change the period of limited-range block ops from 5 to 10 minutes.
    + Improve instrumentation performance on 32-bit systems by getting rid of
      xor-swap and tweaking alignment.
    + Made path depth numbers more accurate with imported test cases.
    + Fix a bug with afl-cmin in -Q mode complaining about binary being not
      instrumented.
    + Fix another bug with argv handling for afl-fuzz in -Q mode.
    + Improve the use of colors when showing crash counts in -C mode.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 19 Feb 2015 23:57:11 +0100

afl (1.44b-1) experimental; urgency=low

  * New upstream release:
    + Exclude crashing inputs in afl-cmin by default.
    + Add option (-C) for keeping only crashing inputs in afl-cmin.
    + Make the afl-cmin output dir default to 0700, not 0755, to be consistent
      with afl-fuzz; document the rationale for 0755 in afl-plot.


=== debian/control ===
Source: afl
Homepage: http://lcamtuf.coredump.cx/afl/
Section: devel
Priority: optional
Maintainer: Jakub Wilk <jwilk@debian.org>
Build-Depends:
 debhelper (>= 7),
 dh-buildinfo,
 llvm-dev, clang
Standards-Version: 3.9.6

Package: afl
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gcc, g++, afl-clang
Architecture: any
Description: instrumentation-driven fuzzer for binary formats
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary. This substantially
 improves the functional coverage for the fuzzed code. The compact synthesized
 corpora produced by the tool are also useful for seeding other, more labor- or
 resource-intensive testing regimes down the road. 
 .
 afl-fuzz is designed to be practical: it has modest performance overhead, uses
 a variety of highly effective fuzzing strategies, requires essentially no
 configuration, and seamlessly handles complex, real-world use cases - say,
 common image parsing or file compression libraries. 

Package: afl-clang
Depends: afl (= ${binary:Version}),
 clang, ${clang:Depends},
 ${shlibs:Depends}, ${misc:Depends}
Breaks: afl (<< 1.72b)
Replaces: afl (<< 1.72b)
Architecture: any
Description: instrumentation-driven fuzzer for binary formats - clang support
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary.
 .
 This package provides support for the clang compiler.

=== debian/rules ===
#!/usr/bin/make -f

export CFLAGS = $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
export CXXFLAGS = $(CFLAGS)
export LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)

# Support for -fstack-protector in clang is broken on some architectures;
# see bug #785365.
ifneq "$(filter kfreebsd-% powerpc ppc64el,$(shell dpkg-architecture -q DEB_HOST_ARCH))" ""
clang_cflags = $(filter-out -fstack-protector%,$(CFLAGS))
else
clang_cflags = $(CFLAGS)
endif

export HOSTNAME =
export PREFIX = /usr

ifeq "$(filter i386 amd64,$(shell dpkg-architecture -q DEB_HOST_ARCH_CPU))" ""
export AFL_NOX86 = 1
endif

.PHONY: clean
clean: debian/control
	dh_clean
	$(MAKE) clean

.PHONY: build build-arch build-indep
build: build-arch
build-arch: build-stamp

build-stamp: debian/control
	$(MAKE)
	CFLAGS="$(clang_cflags)" CXXFLAGS="$(clang_cflags)" $(MAKE) -C llvm_mode
	touch $(@)

.PHONY: binary binary-arch binary-indep
binary: binary-arch
binary-arch: build-stamp
	dh_testroot
	dh_prep
	$(MAKE) install DESTDIR=debian/tmp
	dh_install --fail-missing
ifneq "$(AFL_NOX86)" ""
	cd debian/afl/usr/bin/ && rm afl-gcc afl-g++
	cd debian/afl/usr/lib/afl/ && rm as afl-as
	cd debian/afl/usr/ && rmdir lib/afl lib
	cd debian/afl-clang/usr/bin/ && rm afl-clang afl-clang++
endif
	dh_lintian
	dh_installchangelogs
	rm debian/*/usr/share/doc/*/ChangeLog
	dh_installdocs -p afl experimental/ docs/vuln_samples
	dh_installdocs -p afl-clang llvm_mode/README*
	dh_buildinfo
	dh_strip
	dh_compress -Xsupport -Xscript
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	debian/dh_clang -p afl-clang
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# vim:ts=4 sw=4 noet

=== debian/watch ===
version=3
http://lcamtuf.coredump.cx/afl/releases/afl-([0-9.]+[a-z]*)[.]tgz$

## afl 1.96b

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 #
 
 PROGNAME    = afl
-VERSION     = 1.83b
+VERSION     = 1.96b
 
 PREFIX     ?= /usr/local
 BIN_PATH    = $(PREFIX)/bin
@@ -132,4 +132,5 @@
 	cat docs/historical_notes.txt >~/www/afl/historical_notes.txt
 	cat docs/technical_details.txt >~/www/afl/technical_details.txt
 	cat docs/ChangeLog >~/www/afl/ChangeLog.txt
+	cat docs/QuickStartGuide.txt >~/www/afl/QuickStartGuide.txt
 	echo -n "$(VERSION)" >~/www/afl/version.txt

=== llvm_mode/Makefile ===
--- 
+++ 
@@ -33,7 +33,7 @@
 CXXFLAGS    += -Wall -D_FORTIFY_SOURCE=2 -g -Wno-pointer-sign \
                -DVERSION=\"$(VERSION)\"
 
-CLANG_CFL    = `$(LLVM_CONFIG) --cxxflags` -fno-rtti $(CXXFLAGS)
+CLANG_CFL    = `$(LLVM_CONFIG) --cxxflags` -fno-rtti -fpic $(CXXFLAGS)
 CLANG_LFL    = `$(LLVM_CONFIG) --ldflags` $(LDFLAGS)
 
 # User teor2345 reports that this is required to make things work on MacOS X.
@@ -80,7 +80,7 @@
 
 test_build: $(PROGS)
 	@echo "[*] Testing the CC wrapper and instrumentation output..."
-	unset AFL_USE_ASAN AFL_USE_MSAN AFL_DEFER_FORKSRV; AFL_QUIET=1 AFL_INST_RATIO=100 AFL_PATH=. AFL_CC=$(CC) ../afl-clang-fast $(CFLAGS) ../test-instr.c -o test-instr $(LDFLAGS)
+	unset AFL_USE_ASAN AFL_USE_MSAN; AFL_QUIET=1 AFL_INST_RATIO=100 AFL_PATH=. AFL_CC=$(CC) ../afl-clang-fast $(CFLAGS) ../test-instr.c -o test-instr $(LDFLAGS)
 	echo 0 | ../afl-showmap -m none -q -o .test-instr0 ./test-instr
 	echo 1 | ../afl-showmap -m none -q -o .test-instr1 ./test-instr
 	@rm -f test-instr

=== debian/changelog ===
afl (1.96b-2) unstable; urgency=medium

  * Build with doc package:
    + added package description to deb/control.
    + added deb/afl-doc.install.
    + removed items from deb/afl.install.
    + moved lintian-overrides to afl-doc.lintian-overrides, updated.
    + deb/rules: use dh_installdocs to contribute README, strip it from
      DOC_PATH in dh_auto_build override; spare doc package from buildinfo.
  * deb/control:
    + bumped standards to 3.9.7 (regarded changes in 12.3).
    + put Architecture fields upward.
  * deb/rules:
    + added DEB_BUILD_MAINT_OPTIONS with hardening=+all (for PIE and BINDNOW).
    + add README to excludes for dh_compress (Closes: #813503).
  * deb/changelog:
    + expanded copyright span.

 -- Daniel Stender <debian@danielstender.com>  Thu, 18 Feb 2016 12:08:19 +0100

afl (1.96b-1) unstable; urgency=medium

  * New upstream release.
  * deb/control:
    + restored Vcs-Git and Browser (requested for downstream development).
  * deb/rules:
    + strip ChangeLog in DOC_PATH by dh_auto_install override (saves override
      for dh_installchangelogs).
    + added some excludes to dh_compress, removed obsolete.
    + run dh_clang before gencontrol (still disabled).
    + checked appearance of overrides according to build sequence.
  * hardcode-clang-version.patch: removed Dgit stamp from patch header, arranged
    more strictly for DEP-3, toggled forwarded to "not-needed".
  * Dropped deb/source/options (setting gzip compression).

 -- Daniel Stender <debian@danielstender.com>  Tue, 02 Feb 2016 00:11:05 +0100

afl (1.95b-3) unstable; urgency=medium

  * Hardcode current LLVM/clang version in debian/ files and in the
    source (added hardcode-llvm-version.patch) to prevent crash of
    afl-clang-fast because default build-time and runtime version
    differs (Closes: #807578).

 -- Daniel Stender <debian@danielstender.com>  Thu, 07 Jan 2016 00:33:02 +0100

afl (1.95b-2) unstable; urgency=medium

  * Upload to unstable.
  * deb/rules: restored the portion on disabling -fstack-protector (the
    problem remains also with clang-3-6).

    (missing in the previous entry: experimental changes in deb/rules on
     disabling -fstack-protector on some architectures)

 -- Daniel Stender <debian@danielstender.com>  Thu, 03 Dec 2015 15:54:27 +0100

afl (1.95b-1) experimental; urgency=medium

  * New upstream release.
  * deb/control: dropped Vcs-Git and Browser (not collaboratively maintained,
    Git log not needed anymore for review of changes in sponsoring).
  * deb/rules: rewritten for dh sequencer.
  * Removed deb/gbp.conf (not needed now).

 -- Daniel Stender <debian@danielstender.com>  Wed, 02 Dec 2015 22:47:13 +0100

afl (1.94b-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Stender <debian@danielstender.com>  Sat, 03 Oct 2015 19:43:02 +0200

afl (1.92b-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Stender <debian@danielstender.com>  Tue, 08 Sep 2015 10:12:33 +0200

afl (1.89b-1) unstable; urgency=medium

  * New upstream release (Closes: #797681).
  * afl-showmap.1: corrected typo.

 -- Daniel Stender <debian@danielstender.com>  Wed, 02 Sep 2015 18:43:08 +0200

afl (1.87b-1) unstable; urgency=medium

  * New upstream release.
  * deb/control: although clang-3.5 on arm64 won't (see #796343), don't
    disable any arch.
  * deb/rules: let dh_installdocs handle experimental/persistent_demo, not
    deb/afl-clang.install.
  * deb/watch: better to watch for multiple common extensions.
  * Added deb/gbp.conf.
  * Removed empty deb/patches.
  * Wrap-and-sort on deb/afl{,-clang}.manpages.

 -- Daniel Stender <debian@danielstender.com>  Wed, 26 Aug 2015 21:26:32 +0200

afl (1.86b-1) unstable; urgency=medium

  * New upstream release.
  * Change of maintainer (Closes: #786806).
  * Added manpages (deb/manpages, deb/afl{,-clang}.manpages and
    dh_installman to deb/rules, Closes: #793905).
  * deb/control:
    + don't build on arm64 temporarily due to #796343.
    + bumped debhelper level to 9 (deb/compat along).
    + added gnuplot to Recommends.
    + added Vcs- fields (put package into collab-maint).
    + moved Homepage: further down.
    + strip trailing whitespace [Jakub Wilk].
  * deb/copyright:
    + added myself to copyright owners of debian/.
    + connect year figures with hyphen.
  * deb/rules:
    + added s390x to -fstack-protector disabled archs (see #785365).
  * Put experimental/persistent_demo into afl-clang package (deb/rules,
    deb/afl-clang.install, Closes: #794293).
  * Wrap-and-sort -a -s.

 -- Daniel Stender <debian@danielstender.com>  Tue, 25 Aug 2015 15:41:37 +0200

=== debian/control ===
Source: afl
Section: devel
Priority: optional
Maintainer: Daniel Stender <debian@danielstender.com>
Build-Depends:
 clang-3.6,
 debhelper (>= 9),
 dh-buildinfo,
 llvm-3.6-dev
Standards-Version: 3.9.7
Homepage: http://lcamtuf.coredump.cx/afl/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/afl.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/afl.git

Package: afl
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 afl-clang,
 g++,
 gcc,
 gnuplot,
 afl-doc
Description: instrumentation-driven fuzzer for binary formats
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary. This substantially
 improves the functional coverage for the fuzzed code. The compact synthesized
 corpora produced by the tool are also useful for seeding other, more labor- or
 resource-intensive testing regimes down the road.
 .
 afl-fuzz is designed to be practical: it has modest performance overhead, uses
 a variety of highly effective fuzzing strategies, requires essentially no
 configuration, and seamlessly handles complex, real-world use cases - say,
 common image parsing or file compression libraries.

Package: afl-clang
Architecture: any
Depends:
 afl (= ${binary:Version}),
 clang-3.6,
 ${clang:Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 afl-doc
Breaks:
 afl (<< 1.72b)
Replaces:
 afl (<< 1.72b)
Description: instrumentation-driven fuzzer for binary formats - clang support
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary.
 .
 This package provides support for the clang compiler.

Package: afl-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends}
Recommends:
 afl,
 afl-clang
Breaks:
 afl (<= 1.96b-1)
Description: instrumentation-driven fuzzer for binary formats - documentation
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary.
 .
 This package provides the documentation, a collection of special crafted test
 cases, vulnerability samples and experimental stuff.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Support for -fstack-protector in clang is broken on some architectures;
# see bug #785365.
ifneq "$(filter kfreebsd-% powerpc ppc64el s390x,$(shell dpkg-architecture -q DEB_HOST_ARCH))" ""
clang_cflags = $(filter-out -fstack-protector%,$(CFLAGS))
else
clang_cflags = $(CFLAGS)
endif

export HOSTNAME =
export PREFIX = /usr

ifeq "$(filter i386 amd64,$(shell dpkg-architecture -q DEB_HOST_ARCH_CPU))" ""
export AFL_NOX86 = 1
endif

%:
	dh $@

override_dh_auto_build:
	$(MAKE)
	CFLAGS="$(clang_cflags)" CXXFLAGS="$(clang_cflags)" $(MAKE) -C llvm_mode

override_dh_auto_install:
	$(MAKE) install DESTDIR=debian/tmp
	rm debian/tmp/usr/share/doc/afl/ChangeLog
	rm debian/tmp/usr/share/doc/afl/README
	dh_install --fail-missing
ifneq "$(AFL_NOX86)" ""
	cd debian/afl/usr/bin/ && rm afl-gcc afl-g++
	cd debian/afl/usr/lib/afl/ && rm as afl-as
	cd debian/afl/usr/ && rmdir lib/afl lib
	cd debian/afl-clang/usr/bin/ && rm afl-clang afl-clang++
endif

override_dh_installdocs:
	dh_installdocs -A docs/README
	dh_buildinfo -Nafl-doc

override_dh_strip_nondeterminism:
	# not needed, and don't touch testcases and vuln_samples (see e.g. #803503)

override_dh_compress:
	dh_compress -X.c -X.mp4 -X.sql -XREADME

override_dh_gencontrol:
#	debian/dh_clang -p afl-clang
	dh_gencontrol

## afl 2.33b

=== debian/changelog ===
afl (2.33b-4) unstable; urgency=medium

  * upload to unstable (Closes: #835352).

 -- Daniel Stender <stender@debian.org>  Fri, 02 Sep 2016 08:36:51 +0200

afl (2.33b-3) experimental; urgency=medium

  * deb/rules:
    + add missing empty override for dh_install.
    + don't try to remove non-empty /usr/lib/afl on non-x86 archs (ship
      libdislocator and libtokencap).

 -- Daniel Stender <stender@debian.org>  Mon, 29 Aug 2016 11:03:52 +0200

afl (2.33b-2) experimental; urgency=medium

  * build and ship libdislocator and libtokencap:
    + add make invocations for both companion libraries in deb/rules (build
      them with custom CFLAGS and LDFLAGS without -fPIE).
    + add libraries and READMEs to deb/afl{,-doc}-install.
    + add info on them in deb/afl.NEWS.
  * deb/afl-doc.install: include llvm_mode/README.llvm.
  * add deb/clean (with llvm_mode/afl-llvm-pass.dwo).

 -- Daniel Stender <stender@debian.org>  Sun, 28 Aug 2016 21:46:35 +0200

afl (2.33b-1) experimental; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Sat, 27 Aug 2016 21:58:43 +0200

afl (2.30b-1) experimental; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Sat, 13 Aug 2016 20:31:35 +0200

afl (2.28b-1) experimental; urgency=medium

  * New upstream release:
    + unfuzz avoid-builtin-return-address.patch.
  * build/run against/on llvm 3.8 (Closes: #828178):
    + update build and package deps in deb/control.
    + update hardcode-clang-version.patch.
  * deb/control:
    + put gnuplot into Suggests (thanks to Michał Staruch for pointer).
    + let binary depend on build-essential, and better in Depends.

 -- Daniel Stender <stender@debian.org>  Sun, 07 Aug 2016 14:57:25 +0200

afl (2.21b-1) unstable; urgency=medium

  * New upstream release.
  * deb/afl-doc.lintian-overrides: drop obsolete override.

 -- Daniel Stender <stender@debian.org>  Mon, 25 Jul 2016 20:12:38 +0200

afl (2.17b-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Thu, 30 Jun 2016 10:26:30 +0200

afl (2.16b-1) unstable; urgency=medium

  * New upstream release.
  * Unfuzzed hardcode-clang-version.patch.

 -- Daniel Stender <stender@debian.org>  Fri, 24 Jun 2016 16:59:31 +0200

afl (2.14b-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Fri, 10 Jun 2016 11:11:08 +0200

afl (2.13b-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Tue, 17 May 2016 20:46:21 +0200

afl (2.12b-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Thu, 05 May 2016 13:42:59 +0200

afl (2.11b-1) unstable; urgency=medium

  * New upstream release.
  * deb/control: bumped Standards-Version to 3.9.8 (no changes needed).

 -- Daniel Stender <stender@debian.org>  Fri, 29 Apr 2016 10:26:13 +0200

afl (2.10b-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Tue, 05 Apr 2016 08:49:52 +0200

afl (2.09b-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Wed, 30 Mar 2016 10:28:45 +0200

afl (2.08b-4) unstable; urgency=medium

  * Added avoid-builtin-return-address.patch (Closes: #818288).

 -- Daniel Stender <stender@debian.org>  Thu, 24 Mar 2016 23:24:52 +0100

afl (2.08b-3) unstable; urgency=medium

  * build against llvm/clang 3.7 (changes in deb/control and
    hardcode-clang-version.patch).

 -- Daniel Stender <stender@debian.org>  Wed, 16 Mar 2016 09:45:13 +0100

afl (2.08b-2) unstable; urgency=medium

  * deb/afl-clang.install: install afl-lvm-rt*.o (using wildcard).

 -- Daniel Stender <stender@debian.org>  Tue, 15 Mar 2016 14:08:26 +0100

afl (2.08b-1) unstable; urgency=medium

  * New upstream release.
  * deb/rules: s/AFL_NOX86/AFL_NO_X86/.
  * deb/afl.install: added afl-analyze.
  * deb/afl-clang.install: added afl-llvm-rt-64.o.
  * Unfuzzed hardcode-clang-version.patch.
  * Updated deb/control, deb/copyright.
  * Manpages: added afl-analyze.1, updated all and cosmetics, removed
    dates.

 -- Daniel Stender <stender@debian.org>  Tue, 15 Mar 2016 12:48:07 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: afl
 Section: devel
 Priority: optional
-Maintainer: Daniel Stender <debian@danielstender.com>
+Maintainer: Daniel Stender <stender@debian.org>
 Build-Depends:
- clang-3.6,
+ clang-3.8,
  debhelper (>= 9),
  dh-buildinfo,
- llvm-3.6-dev
-Standards-Version: 3.9.7
+ llvm-3.8-dev
+Standards-Version: 3.9.8
 Homepage: http://lcamtuf.coredump.cx/afl/
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/afl.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/afl.git
@@ -15,14 +15,14 @@
 Package: afl
 Architecture: any
 Depends:
+ build-essential,
  ${misc:Depends},
  ${shlibs:Depends}
 Recommends:
  afl-clang,
- g++,
- gcc,
- gnuplot,
  afl-doc
+Suggests:
+ gnuplot
 Description: instrumentation-driven fuzzer for binary formats
  American fuzzy lop is a fuzzer that employs compile-time instrumentation and
  genetic algorithms to automatically discover clean, interesting test cases
@@ -40,7 +40,7 @@
 Architecture: any
 Depends:
  afl (= ${binary:Version}),
- clang-3.6,
+ clang-3.8,
  ${clang:Depends},
  ${misc:Depends},
  ${shlibs:Depends}

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,9 @@
 #export DH_VERBOSE=1
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+cflags_nopie = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie dpkg-buildflags --get CFLAGS)
+ldflags_nopie = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie dpkg-buildflags --get LDFLAGS)
 
 # Support for -fstack-protector in clang is broken on some architectures;
 # see bug #785365.
@@ -15,7 +18,7 @@
 export PREFIX = /usr
 
 ifeq "$(filter i386 amd64,$(shell dpkg-architecture -q DEB_HOST_ARCH_CPU))" ""
-export AFL_NOX86 = 1
+export AFL_NO_X86 = 1
 endif
 
 %:
@@ -23,19 +26,24 @@
 
 override_dh_auto_build:
 	$(MAKE)
+	CFLAGS="$(cflags_nopie)" LDFLAGS="$(ldflags_nopie)" $(MAKE) -C libdislocator
+	CFLAGS="$(cflags_nopie)" LDFLAGS="$(ldflags_nopie)" $(MAKE) -C libtokencap
 	CFLAGS="$(clang_cflags)" CXXFLAGS="$(clang_cflags)" $(MAKE) -C llvm_mode
 
 override_dh_auto_install:
 	$(MAKE) install DESTDIR=debian/tmp
 	rm debian/tmp/usr/share/doc/afl/ChangeLog
 	rm debian/tmp/usr/share/doc/afl/README
+	$(MAKE) -C libdislocator install DESTDIR=$(CURDIR)/debian/tmp
+	$(MAKE) -C libtokencap install DESTDIR=$(CURDIR)/debian/tmp
 	dh_install --fail-missing
-ifneq "$(AFL_NOX86)" ""
+ifneq "$(AFL_NO_X86)" ""
 	cd debian/afl/usr/bin/ && rm afl-gcc afl-g++
 	cd debian/afl/usr/lib/afl/ && rm as afl-as
-	cd debian/afl/usr/ && rmdir lib/afl lib
 	cd debian/afl-clang/usr/bin/ && rm afl-clang afl-clang++
 endif
+
+override_dh_install:
 
 override_dh_installdocs:
 	dh_installdocs -A docs/README

## afl 2.36b

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 #
 # Written and maintained by Michal Zalewski <lcamtuf@google.com>
 # 
-# Copyright 2013, 2014, 2015 Google Inc. All rights reserved.
+# Copyright 2013, 2014, 2015, 2016 Google Inc. All rights reserved.
 # 
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -14,7 +14,7 @@
 #
 
 PROGNAME    = afl
-VERSION     = 1.96b
+VERSION     = $(shell grep '^\#define VERSION ' config.h | cut -d '"' -f2)
 
 PREFIX     ?= /usr/local
 BIN_PATH    = $(PREFIX)/bin
@@ -22,12 +22,15 @@
 DOC_PATH    = $(PREFIX)/share/doc/afl
 MISC_PATH   = $(PREFIX)/share/afl
 
-PROGS       = afl-gcc afl-as afl-fuzz afl-showmap afl-tmin afl-gotcpu
+# PROGS intentionally omit afl-as, which gets installed elsewhere.
+
+PROGS       = afl-gcc afl-fuzz afl-showmap afl-tmin afl-gotcpu afl-analyze
+SH_PROGS    = afl-plot afl-cmin afl-whatsup
 
 CFLAGS     ?= -O3 -funroll-loops
 CFLAGS     += -Wall -D_FORTIFY_SOURCE=2 -g -Wno-pointer-sign \
 	      -DAFL_PATH=\"$(HELPER_PATH)\" -DDOC_PATH=\"$(DOC_PATH)\" \
-	      -DBIN_PATH=\"$(BIN_PATH)\" -DVERSION=\"$(VERSION)\"
+	      -DBIN_PATH=\"$(BIN_PATH)\"
 
 ifneq "$(filter Linux GNU%,$(shell uname))" ""
   LDFLAGS  += -ldl
@@ -41,20 +44,20 @@
 
 COMM_HDR    = alloc-inl.h config.h debug.h types.h
 
-all: test_x86 $(PROGS) test_build all_done
+all: test_x86 $(PROGS) afl-as test_build all_done
 
-ifndef AFL_NOX86
+ifndef AFL_NO_X86
 
 test_x86:
 	@echo "[*] Checking for the ability to compile x86 code..."
-	@echo 'main() { __asm__("xorb %al, %al"); }' | $(CC) -w -x c - -o .test || ( echo; echo "Oops, looks like your compiler can't generate x86 code."; echo; echo "You can still try using the LLVM or QEMU mode, but see docs/INSTALL first."; echo "To ignore this error, set AFL_NOX86=1."; echo; exit 1 )
+	@echo 'main() { __asm__("xorb %al, %al"); }' | $(CC) -w -x c - -o .test || ( echo; echo "Oops, looks like your compiler can't generate x86 code."; echo; echo "Don't panic! You can use the LLVM or QEMU mode, but see docs/INSTALL first."; echo "(To ignore this error, set AFL_NO_X86=1 and try again.)"; echo; exit 1 )
 	@rm -f .test
 	@echo "[+] Everything seems to be working, ready to compile."
 
 else
 
 test_x86:
-	@echo "[!] Note: skipping x86 compilation checks (AFL_NOX86 set)."
+	@echo "[!] Note: skipping x86 compilation checks (AFL_NO_X86 set)."
 
 endif
 
@@ -63,7 +66,7 @@
 	set -e; for i in afl-g++ afl-clang afl-clang++; do ln -sf afl-gcc $$i; done
 
 afl-as: afl-as.c afl-as.h $(COMM_HDR) | test_x86
-	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS) 
+	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS)
 	ln -sf afl-as as
 
 afl-fuzz: afl-fuzz.c $(COMM_HDR) | test_x86
@@ -75,10 +78,13 @@
 afl-tmin: afl-tmin.c $(COMM_HDR) | test_x86
 	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS)
 
+afl-analyze: afl-analyze.c $(COMM_HDR) | test_x86
+	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS)
+
 afl-gotcpu: afl-gotcpu.c $(COMM_HDR) | test_x86
 	$(CC) $(CFLAGS) $@.c -o $@ $(LDFLAGS)
 
-ifndef AFL_NOX86
+ifndef AFL_NO_X86
 
 test_build: afl-gcc afl-as afl-showmap
 	@echo "[*] Testing the CC wrapper and instrumentation output..."
@@ -97,6 +103,7 @@
 endif
 
 all_done: test_build
+	@if [ ! "`which clang 2>/dev/null`" = "" ]; then echo "[+] LLVM users: see llvm_mode/README.llvm for a faster alternative to afl-gcc."; fi
 	@echo "[+] All done! Be sure to review README - it's pretty short and useful."
 	@if [ "`uname`" = "Darwin" ]; then printf "\nWARNING: Fuzzing on MacOS X is slow because of the unusually high overhead of\nfork() on this OS. Consider using Linux or *BSD. You can also use VirtualBox\n(virtualbox.org) to put AFL inside a Linux or *BSD VM.\n\n"; fi
 	@! tty <&1 >/dev/null || printf "\033[0;30mNOTE: If you can read this, your terminal probably uses white background.\nThis will make the UI hard to read. See docs/status_screen.txt for advice.\033[0m\n" 2>/dev/null
@@ -104,25 +111,31 @@
 .NOTPARALLEL: clean
 
 clean:
-	rm -f $(PROGS) as afl-g++ afl-clang afl-clang++ *.o *~ a.out core core.[1-9][0-9]* *.stackdump test .test test-instr .test-instr0 .test-instr1 qemu_mode/qemu-2.3.0.tar.bz2 afl-qemu-trace
+	rm -f $(PROGS) afl-as as afl-g++ afl-clang afl-clang++ *.o *~ a.out core core.[1-9][0-9]* *.stackdump test .test test-instr .test-instr0 .test-instr1 qemu_mode/qemu-2.3.0.tar.bz2 afl-qemu-trace
 	rm -rf out_dir qemu_mode/qemu-2.3.0
 	$(MAKE) -C llvm_mode clean
+	$(MAKE) -C libdislocator clean
+	$(MAKE) -C libtokencap clean
 
 install: all
 	mkdir -p -m 755 $${DESTDIR}$(BIN_PATH) $${DESTDIR}$(HELPER_PATH) $${DESTDIR}$(DOC_PATH) $${DESTDIR}$(MISC_PATH)
 	rm -f $${DESTDIR}$(BIN_PATH)/afl-plot.sh
-	install -m 755 afl-gcc afl-fuzz afl-showmap afl-plot afl-tmin afl-cmin afl-gotcpu afl-whatsup $${DESTDIR}$(BIN_PATH)
+	install -m 755 $(PROGS) $(SH_PROGS) $${DESTDIR}$(BIN_PATH)
+	rm -f $${DESTDIR}$(BIN_PATH)/afl-as
 	if [ -f afl-qemu-trace ]; then install -m 755 afl-qemu-trace $${DESTDIR}$(BIN_PATH); fi
 	if [ -f afl-clang-fast -a -f afl-llvm-pass.so -a -f afl-llvm-rt.o ]; then set -e; install -m 755 afl-clang-fast $${DESTDIR}$(BIN_PATH); ln -sf afl-clang-fast $${DESTDIR}$(BIN_PATH)/afl-clang-fast++; install -m 755 afl-llvm-pass.so afl-llvm-rt.o $${DESTDIR}$(HELPER_PATH); fi
+	if [ -f afl-llvm-rt-32.o ]; then set -e; install -m 755 afl-llvm-rt-32.o $${DESTDIR}$(HELPER_PATH); fi
+	if [ -f afl-llvm-rt-64.o ]; then set -e; install -m 755 afl-llvm-rt-64.o $${DESTDIR}$(HELPER_PATH); fi
 	set -e; for i in afl-g++ afl-clang afl-clang++; do ln -sf afl-gcc $${DESTDIR}$(BIN_PATH)/$$i; done
 	install -m 755 afl-as $${DESTDIR}$(HELPER_PATH)
 	ln -sf afl-as $${DESTDIR}$(HELPER_PATH)/as
 	install -m 644 docs/README docs/ChangeLog docs/*.txt $${DESTDIR}$(DOC_PATH)
 	cp -r testcases/ $${DESTDIR}$(MISC_PATH)
+	cp -r dictionaries/ $${DESTDIR}$(MISC_PATH)
 
 publish: clean
 	test "`basename $$PWD`" = "afl" || exit 1
-	test -f ~/www/afl/releases/$(PROGNAME)-$(VERSION).tgz; if [ "$$?" = "0" ]; then echo; echo "Change program version in Makefile, mmkay?"; echo; exit 1; fi
+	test -f ~/www/afl/releases/$(PROGNAME)-$(VERSION).tgz; if [ "$$?" = "0" ]; then echo; echo "Change program version in config.h, mmkay?"; echo; exit 1; fi
 	cd ..; rm -rf $(PROGNAME)-$(VERSION); cp -pr $(PROGNAME) $(PROGNAME)-$(VERSION); \
 	  tar -cvz -f ~/www/afl/releases/$(PROGNAME)-$(VERSION).tgz $(PROGNAME)-$(VERSION)
 	chmod 644 ~/www/afl/releases/$(PROGNAME)-$(VERSION).tgz

=== debian/changelog ===
afl (2.36b-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Thu, 19 Jan 2017 17:43:30 +0100

afl (2.35b-1) unstable; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Mon, 28 Nov 2016 22:39:27 +0100

afl (2.34b-6) unstable; urgency=medium

  * Uploaded to unstable.

 -- Daniel Stender <stender@debian.org>  Sun, 20 Nov 2016 10:41:00 +0100

afl (2.34b-5) experimental; urgency=medium

  * deb/rules:
    + pass custom mfpu also to $CXXFLAGS (Closes: #841474) [thanks to Michal
      Zaleswki].
    + corrected an error in the info text.

 -- Daniel Stender <stender@debian.org>  Sat, 19 Nov 2016 22:39:34 +0100

afl (2.34b-4) experimental; urgency=medium

  * use "vfpv3" to set mfpu.

 -- Daniel Stender <stender@debian.org>  Fri, 18 Nov 2016 17:40:00 +0100

afl (2.34b-3) experimental; urgency=medium

  * deb/rules:
    + add -mfpu=vfp3 to $CFLAGS for clang on armhf (Closes: #841474).
    + pass $clang_cflags to make -C llvm_mode.
    + drop removal of -fstack-protector from $CFLAGS for clang (not needed
      anymore).

 -- Daniel Stender <stender@debian.org>  Mon, 14 Nov 2016 14:00:47 +0100

afl (2.34b-2) unstable; urgency=medium

  * Upload to unstable.

 -- Daniel Stender <stender@debian.org>  Sun, 25 Sep 2016 20:17:52 +0200

afl (2.34b-1) experimental; urgency=medium

  * New upstream release.

 -- Daniel Stender <stender@debian.org>  Mon, 19 Sep 2016 08:38:38 +0200

afl (2.33b-6) experimental; urgency=medium

  * deb/rules: enable fstack-protector flag on all archs
    (Closes: #786599).
  * drop avoid-builtin-return-address.patch (not needed anymore).

 -- Daniel Stender <stender@debian.org>  Wed, 07 Sep 2016 16:36:02 +0200

afl (2.33b-5) experimental; urgency=medium

  * unfuzz avoid-builtin-return-address.patch.
  * build/run against llvm/clang 3.9.

 -- Daniel Stender <stender@debian.org>  Tue, 06 Sep 2016 14:03:41 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: optional
 Maintainer: Daniel Stender <stender@debian.org>
 Build-Depends:
- clang-3.8,
+ clang-3.9,
  debhelper (>= 9),
  dh-buildinfo,
- llvm-3.8-dev
+ llvm-3.9-dev
 Standards-Version: 3.9.8
 Homepage: http://lcamtuf.coredump.cx/afl/
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/afl.git
@@ -40,7 +40,7 @@
 Architecture: any
 Depends:
  afl (= ${binary:Version}),
- clang-3.8,
+ clang-3.9,
  ${clang:Depends},
  ${misc:Depends},
  ${shlibs:Depends}

=== debian/rules ===
--- 
+++ 
@@ -6,12 +6,11 @@
 cflags_nopie = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie dpkg-buildflags --get CFLAGS)
 ldflags_nopie = $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie dpkg-buildflags --get LDFLAGS)
 
-# Support for -fstack-protector in clang is broken on some architectures;
-# see bug #785365.
-ifneq "$(filter kfreebsd-% powerpc ppc64el s390x,$(shell dpkg-architecture -q DEB_HOST_ARCH))" ""
-clang_cflags = $(filter-out -fstack-protector%,$(CFLAGS))
-else
-clang_cflags = $(CFLAGS)
+# don't emit NEON instructions whatsoever to prevent FTBFS on machines which
+# doesn't support that, see #842143 [thanks to Paul Wise]
+ifeq "$(shell dpkg-architecture -q DEB_HOST_ARCH)" "armhf"
+clang_cflags := $(CFLAGS) -mfpu=vfpv3
+clang_cxxflags := $(CXXFLAGS) -mfpu=vfpv3
 endif
 
 export HOSTNAME =
@@ -28,7 +27,7 @@
 	$(MAKE)
 	CFLAGS="$(cflags_nopie)" LDFLAGS="$(ldflags_nopie)" $(MAKE) -C libdislocator
 	CFLAGS="$(cflags_nopie)" LDFLAGS="$(ldflags_nopie)" $(MAKE) -C libtokencap
-	CFLAGS="$(clang_cflags)" CXXFLAGS="$(clang_cflags)" $(MAKE) -C llvm_mode
+	CFLAGS="$(clang_cflags)" CXXFLAGS="$(clang_cxxflags)" $(MAKE) -C llvm_mode
 
 override_dh_auto_install:
 	$(MAKE) install DESTDIR=debian/tmp
